
#include "descriptor/descriptor.h"

int main(void) {

	ITEM	parete,metallo,vetro;

	ITEM	tavolo,poltrona,camino,esternocamino,bucocamino;

	ITEM	stanza,paretedietro,paretedx,paretesotto,paretesopra;

	ITEM	beccolampada,tlampada,baselampada,supportolampada,vetrolampada;

	ITEM 	serpente,pelleserpente,gola,occhiodx,occhiosx,gengsx,gengdx;

	ITEM	scena;

	/* TEXTURE */
	char * legno_pav = "textures/pavimentolegno.hr";
	char * tav_legno = "textures/legnotavolo.hr";
 	char * stoffa_p = "textures/stoffa.hr";
	char * muro = "textures/muro.hr";
	char * sfondocamino = "textures/brickta.hr";
	char * internocamino = "textures/internocamino.hr";
	char * rosa = "textures/rosa.hr";
	char * skin = "textures/snakeskin.hr";

	set_background(1,1,0.5,TRUE);
	set_ambient_light(1,1,1,.5);
	create_point_light(3.300, 0.535, 5.300,1,1,1,1.0,10,"luce");
	create_point_light(4.779, 22.367, 2.612,1,1,1,1.0,35,"luce2");

//.........ATTRIBUTI*/
	/***metallo ***/
	metallo = create_attribute("metallo");
	set_color(metallo,0.47,0.47,0.47,0.33,0.36);
 	set_reflectivity(metallo,0.17,2);

	/***parete ***/
	parete = create_attribute("parete");
	set_color(parete,0.95,0.7,0.1,0.1,0.1);

	/**** vetro ***/
	vetro=create_attribute("vetro");
	set_color(vetro,0.68,0.86,1,0.5,0.5);
	set_reflectivity(vetro,0.24,2);
	set_transparency(vetro,0.87,0.68,1,1.2);

//---------------------------------------------------------------

 	paretedietro = read_nurbs("paretedietro.db");
	set_domain_texture(paretedietro, parete, muro, 0, 0.5, 0, 0.5, 1, 0.6, 0.8);

 	paretedx = read_nurbs("paretedx.db");
	set_domain_texture(paretedx, parete, muro, 0, 0.5, 0, 0.5, 1, 0.6, 0.8);

	paretesopra=read_nurbs("paretesopra.db");
	set_domain_texture(paretesopra, parete, muro, 0, 0.5, 0, 0.5, 1, 0.6, 0.8);

	paretesotto=read_nurbs("paretesotto.db");
	set_domain_texture(paretesotto, parete, legno_pav, 0, 0.5, 0, 0.5, 1, 0.6, 0.8);

	stanza = create_list(paretedietro,"stanza");
	stanza = insert_in_list(stanza,paretedx);
	stanza = insert_in_list(stanza,paretesopra);
	stanza = insert_in_list(stanza,paretesotto);

//--------LAMPADA
	baselampada = read_nurbs("baselampada.db");
 	set_attribute(baselampada,metallo);

	supportolampada = read_nurbs("supportolampada.db");
 	set_attribute(supportolampada,metallo);

	beccolampada = read_nurbs("beccolampada.db");
 	set_attribute(beccolampada,metallo);

 	vetrolampada = read_nurbs("vetrolampada.db");
 	set_attribute(vetrolampada, vetro);

	tlampada = create_list(baselampada, "tlampada");
	tlampada = insert_in_list(tlampada,supportolampada);
	tlampada = insert_in_list(tlampada,beccolampada);
 	tlampada = insert_in_list(tlampada,vetrolampada);

//--------Poltrona
	/**** POLTRONA ****/
	poltrona = read_obj("totalepoltrona.obj", "poltrona");
 	set_domain_texture(poltrona, parete, stoffa_p, 0, 0.5, 0, 0.5, 1, 0.6, 0.8);

	/**** TAVOLO ****/
 	tavolo = read_obj("totaletavolo.obj", "tavolo");
	set_domain_texture(tavolo, parete, tav_legno, 0, 0.5, 0, 0.5, 1, 0.6, 0.8);

	/**** CAMINO ****/
	esternocamino = read_nurbs("camino.dbe");
  	set_domain_texture(esternocamino, parete, sfondocamino, 0, 0.5, 0, 0.5, 1, 0.6, 0.8);

	bucocamino = read_nurbs("bucocamino.db");
  	set_domain_texture(bucocamino, parete, internocamino, 0, 0.5, 0, 0.5, 1, 0.6, 0.8);

	camino = create_list(esternocamino, "camino");
	camino = insert_in_list(camino,bucocamino);

//--------Serpente
	pelleserpente = read_nurbs("pelleserpente.dbe");
	set_domain_texture(pelleserpente, parete, skin, 0, 0.5, 0, 0.5, 1, 0.6, 0.8);
	gola = read_nurbs("rosa.db");
	set_domain_texture(gola, parete, rosa, 0, 0.5, 0, 0.5, 1, 0.6, 0.8);
	occhiodx = read_nurbs("occhiodx.db");
	set_domain_texture(occhiodx, parete, skin, 0, 0.5, 0, 0.5, 1, 0.6, 0.8);
	occhiosx = read_nurbs("occhiosx.db");
	set_domain_texture(occhiosx, parete, skin, 0, 0.5, 0, 0.5, 1, 0.6, 0.8);
	gengsx = read_nurbs("gengsx.db");
	set_domain_texture(gengsx, parete, rosa, 0, 0.5, 0, 0.5, 1, 0.6, 0.8);
	gengdx = read_nurbs("gengdx.db");
	set_domain_texture(gengdx, parete, rosa, 0, 0.5, 0, 0.5, 1, 0.6, 0.8);

	serpente = create_list(pelleserpente,"serpente");
	serpente = insert_in_list(serpente,gola);
	serpente = insert_in_list(serpente,occhiosx);
	serpente = insert_in_list(serpente,occhiodx);
	serpente = insert_in_list(serpente,gengdx);
	serpente = insert_in_list(serpente,gengsx);

//.........Scena Finale
	scena = create_list(stanza, "scena");
  	scena = insert_in_list(scena,camino);
  	scena = insert_in_list(scena,tavolo);
	scena = insert_in_list(scena,tlampada);
	scena = insert_in_list(scena,poltrona);
	scena = insert_in_list(scena,serpente);

	save_scene("scena.md","scena_stanza",scena);
	return(0);
}
